import { useAsync } from '@react-devui/hooks';
import { cloneHTMLElement } from '../../utils';
import { isPrintableCharacter } from './utils';
export function DComboboxKeyboard(props) {
    const { children, dVisible, dEditable, dHasSub, onVisibleChange, onFocusChange } = props;
    const async = useAsync();
    return children({
        render: (el) => cloneHTMLElement(el, {
            onKeyDown: (e) => {
                var _a, _b;
                (_b = (_a = el.props).onKeyDown) === null || _b === void 0 ? void 0 : _b.call(_a, e);
                let code = e.code;
                if (code === 'Escape') {
                    e.preventDefault();
                    onVisibleChange(false);
                }
                else {
                    if (dVisible) {
                        if (!dHasSub && ['ArrowLeft', 'ArrowRight'].includes(code)) {
                            code = null;
                        }
                        switch (code) {
                            case 'ArrowUp':
                                e.preventDefault();
                                onFocusChange('prev');
                                break;
                            case 'ArrowDown':
                                e.preventDefault();
                                onFocusChange('next');
                                break;
                            case 'Home':
                                e.preventDefault();
                                onFocusChange('first');
                                break;
                            case 'End':
                                e.preventDefault();
                                onFocusChange('last');
                                break;
                            case 'ArrowLeft':
                                e.preventDefault();
                                onFocusChange('prev-level');
                                break;
                            case 'ArrowRight':
                                e.preventDefault();
                                onFocusChange('next-level');
                                break;
                            default:
                                break;
                        }
                    }
                    else {
                        if (dEditable && ['Home', 'End', 'Enter', 'Space'].includes(code)) {
                            code = null;
                        }
                        switch (code) {
                            case 'ArrowUp':
                                e.preventDefault();
                                onVisibleChange(true);
                                async.requestAnimationFrame(() => onFocusChange('last'));
                                break;
                            case 'ArrowDown':
                                e.preventDefault();
                                onVisibleChange(true);
                                async.requestAnimationFrame(() => onFocusChange('first'));
                                break;
                            case 'Home':
                                e.preventDefault();
                                onVisibleChange(true);
                                async.requestAnimationFrame(() => onFocusChange('first'));
                                break;
                            case 'End':
                                e.preventDefault();
                                onVisibleChange(true);
                                async.requestAnimationFrame(() => onFocusChange('last'));
                                break;
                            case 'Enter':
                            case 'Space':
                                e.preventDefault();
                                onVisibleChange(true);
                                break;
                            default:
                                if (isPrintableCharacter(e.key)) {
                                    onVisibleChange(true);
                                }
                                break;
                        }
                    }
                }
            },
        }),
    });
}
